- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- Search for |

- File List
- Globals

# ustdio.h File Reference

C API: Unicode stdio-like API. More...

`#include <stdio.h>`
`#include <stdarg.h>`
`#include "unicode/utypes.h"`
`#include "unicode/ucnv.h"`
`#include "unicode/utrans.h"`

Go to the source code of this file.

## Defines
#define | U_EOF 0xFFFF
| When an end of file is encountered, this value can be returned.
## Typedefs
typedef UFILE | UFILE
| Forward declaration of a Unicode-aware file.
## Enumerations
enum | UFileDirection { U_READ = 1, U_WRITE = 2, U_READWRITE = 3 }
| Enum for which direction of stream a transliterator applies to. More...
## Functions
UFILE * | u_fopen (const char *filename, const char *perm, const char *locale, const char *codepage)
| Open a UFILE.
UFILE * | u_finit (FILE *f, const char *locale, const char *codepage)
| Open a UFILE on top of an existing FILE* stream.
UFILE * | u_fstropen (UChar *stringBuf, int32_t capacity, const char *locale)
| Create a UFILE that can be used for localized formatting or parsing.
void | u_fclose (UFILE *file)
| Close a UFILE.
UBool | u_feof (UFILE *f)
| Tests if the UFILE is at the end of the file stream.
void | u_fflush (UFILE *file)
| Flush output of a UFILE.
void | u_frewind (UFILE *file)
| Rewind the file pointer to the beginning of the file.
FILE * | u_fgetfile (UFILE *f)
| Get the FILE* associated with a UFILE.
const char * | u_fgetlocale (UFILE *file)
| Get the locale whose conventions are used to format and parse output.
int32_t | u_fsetlocale (UFILE *file, const char *locale)
| Set the locale whose conventions will be used to format and parse output.
const char * | u_fgetcodepage (UFILE *file)
| Get the codepage in which data is written to and read from the UFILE.
int32_t | u_fsetcodepage (const char *codepage, UFILE *file)
| Set the codepage in which data will be written to and read from the UFILE.
UConverter * | u_fgetConverter (UFILE *f)
| Returns an alias to the converter being used for this file.
int32_t | u_fprintf (UFILE *f, const char *patternSpecification,...)
| Write formatted data to a UFILE.
int32_t | u_vfprintf (UFILE *f, const char *patternSpecification, va_list ap)
| Write formatted data to a UFILE.
int32_t | u_fprintf_u (UFILE *f, const UChar *patternSpecification,...)
| Write formatted data to a UFILE.
int32_t | u_vfprintf_u (UFILE *f, const UChar *patternSpecification, va_list ap)
| Write formatted data to a UFILE.
int32_t | u_fputs (const UChar *s, UFILE *f)
| Write a Unicode to a UFILE.
UChar32 | u_fputc (UChar32 uc, UFILE *f)
| Write a UChar to a UFILE.
int32_t | u_file_write (const UChar *ustring, int32_t count, UFILE *f)
| Write Unicode to a UFILE.
int32_t | u_fscanf (UFILE *f, const char *patternSpecification,...)
| Read formatted data from a UFILE.
int32_t | u_vfscanf (UFILE *f, const char *patternSpecification, va_list ap)
| Read formatted data from a UFILE.
int32_t | u_fscanf_u (UFILE *f, const UChar *patternSpecification,...)
| Read formatted data from a UFILE.
int32_t | u_vfscanf_u (UFILE *f, const UChar *patternSpecification, va_list ap)
| Read formatted data from a UFILE.
UChar * | u_fgets (UChar *s, int32_t n, UFILE *f)
| Read one line of text into a UChar* string from a UFILE.
UChar | u_fgetc (UFILE *f)
| Read a UChar from a UFILE.
UChar32 | u_fgetcx (UFILE *f)
| Read a UChar32 from a UFILE.
UChar32 | u_fungetc (UChar32 c, UFILE *f)
| Unget a UChar from a UFILE.
int32_t | u_file_read (UChar *chars, int32_t count, UFILE *f)
| Read Unicode from a UFILE.
UTransliterator * | u_fsettransliterator (UFILE *file, UFileDirection direction, UTransliterator *adopt, UErrorCode *status)
| Set a transliterator on the UFILE.
int32_t | u_sprintf (UChar *buffer, const char *patternSpecification,...)
| Write formatted data to a Unicode string.
int32_t | u_snprintf (UChar *buffer, int32_t count, const char *patternSpecification,...)
| Write formatted data to a Unicode string.
int32_t | u_vsprintf (UChar *buffer, const char *patternSpecification, va_list ap)
| Write formatted data to a Unicode string.
int32_t | u_vsnprintf (UChar *buffer, int32_t count, const char *patternSpecification, va_list ap)
| Write formatted data to a Unicode string.
int32_t | u_sprintf_u (UChar *buffer, const UChar *patternSpecification,...)
| Write formatted data to a Unicode string.
int32_t | u_snprintf_u (UChar *buffer, int32_t count, const UChar *patternSpecification,...)
| Write formatted data to a Unicode string.
int32_t | u_vsprintf_u (UChar *buffer, const UChar *patternSpecification, va_list ap)
| Write formatted data to a Unicode string.
int32_t | u_vsnprintf_u (UChar *buffer, int32_t count, const UChar *patternSpecification, va_list ap)
| Write formatted data to a Unicode string.
int32_t | u_sscanf (const UChar *buffer, const char *patternSpecification,...)
| Read formatted data from a Unicode string.
int32_t | u_vsscanf (const UChar *buffer, const char *patternSpecification, va_list ap)
| Read formatted data from a Unicode string.
int32_t | u_sscanf_u (const UChar *buffer, const UChar *patternSpecification,...)
| Read formatted data from a Unicode string.
int32_t | u_vsscanf_u (const UChar *buffer, const UChar *patternSpecification, va_list ap)
| Read formatted data from a Unicode string.

## Detailed Description

C API: Unicode stdio-like API.

## Unicode stdio-like C API

This API provides an stdio-like API wrapper around ICU's other formatting and parsing APIs. It is meant to ease the transition of adding Unicode support to a preexisting applications using stdio. The following is a small list of noticable differences between stdio and ICU I/O's ustdio implementation.

- Locale specific formatting and parsing is only done with file IO.
- u_fstropen can be used to simulate file IO with strings. This is similar to the iostream API, and it allows locale specific formatting and parsing to be used.
- This API provides uniform formatting and parsing behavior between platforms (unlike the standard stdio implementations found on various platforms).
- This API is better suited for text data handling than binary data handling when compared to the typical stdio implementation.
- You can specify a Transliterator while using the file IO.
- You can specify a file's codepage separately from the default system codepage.

## Formatting and Parsing Specification

General printf format:
%[format modifier][width][.precision][type modifier][format]

General scanf format:
%[*][format modifier][width][type modifier][format]

format | default printf type | default scanf type | description
E | double | float | Scientific with an uppercase exponent
e | double | float | Scientific with a lowercase exponent
G | double | float | Use E or f for best format
g | double | float | Use e or f for best format
f | double | float | Simple floating point without the exponent
X | int32_t | int32_t | ustdio special uppercase hex radix formatting
x | int32_t | int32_t | ustdio special lowercase hex radix formatting
d | int32_t | int32_t | Decimal format
i | int32_t | int32_t | Same as d
n | int32_t | int32_t | count (write the number of UTF-16 codeunits read/written)
o | int32_t | int32_t | ustdio special octal radix formatting
u | uint32_t | uint32_t | Decimal format
p | void * | void * | Prints the pointer value
s | char * | char * | Use default converter or specified converter from fopen
c | char | char | Use default converter or specified converter from fopen When width is specified for scanf, this acts like a non-NULL-terminated char * string. By default, only one char is written.
S | UChar * | UChar * | Null terminated UTF-16 string
C | UChar | UChar | 16-bit Unicode code unit When width is specified for scanf, this acts like a non-NULL-terminated UChar * string By default, only one codepoint is written.
%[] |  | UChar * | Null terminated UTF-16 string which contains the filtered set of characters specified by the UnicodeSet
%% |  |  | Show a percent sign

Format modifiers

modifier | formats | type | comments
h | d, i, o, x | int16_t | short format
h | u | uint16_t | short format
h | c | char | (Unimplemented) Use invariant converter
h | s | char * | (Unimplemented) Use invariant converter
h | C | char | (Unimplemented) 8-bit Unicode code unit
h | S | char * | (Unimplemented) Null terminated UTF-8 string
l | d, i, o, x | int32_t | long format (no effect)
l | u | uint32_t | long format (no effect)
l | c | N/A | (Unimplemented) Reserved for future implementation
l | s | N/A | (Unimplemented) Reserved for future implementation
l | C | UChar32 | (Unimplemented) 32-bit Unicode code unit
l | S | UChar32 * | (Unimplemented) Null terminated UTF-32 string
ll | d, i, o, x | int64_t | long long format
ll | u | uint64_t | (Unimplemented) long long format
- | all | N/A | Left justify
+ | d, i, o, x, e, f, g, E, G | N/A | Always show the plus or minus sign. Needs data for plus sign.
% | d, i, o, x, e, f, g, E, G | N/A | Instead of a "+" output a blank character for positive numbers.
%# | d, i, o, x, e, f, g, E, G | N/A | Precede octal value with 0, hex with 0x and show the decimal point for floats.
%n | all | N/A | Width of input/output. num is an actual number from 0 to some large number.
%.n | e, f, g, E, F, G | N/A | Significant digits precision. num is an actual number from 0 to some large number. If * is used in printf, then the precision is passed in as an argument before the number to be formatted.

printf modifier * int32_t Next argument after this one specifies the width

scanf modifier * N/A This field is scanned, but not stored

If you are using this C API instead of the ustream.h API for C++, you can use one of the following u_fprintf examples to display a UnicodeString.

        UFILE *out = u_finit(stdout, NULL, NULL);
        UnicodeString string1("string 1");
        UnicodeString string2("string 2");
        u_fprintf(out, "%S\n", string1.getTerminatedBuffer());
        u_fprintf(out, "%.*S\n", string2.length(), string2.getBuffer());
        u_fclose(out);

Definition in file ustdio.h.

## Define Documentation

#define U_EOF 0xFFFF

When an end of file is encountered, this value can be returned.

See also:
  u_fgetc

Stable:
  3.0

Definition at line 203 of file ustdio.h.

## Typedef Documentation

typedef struct UFILE UFILE

Forward declaration of a Unicode-aware file.

Stable:
  3.0

Definition at line 206 of file ustdio.h.

## Enumeration Type Documentation

enum UFileDirection

Enum for which direction of stream a transliterator applies to.

See also:
  u_fsettransliterator

Draft:
  This API may be changed in the future versions and was introduced in 3.0

Definition at line 214 of file ustdio.h.

## Function Documentation

void u_fclose | ( | UFILE * | file | ) |

Close a UFILE.

Parameters:

  | file | The UFILE to close.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

UBool u_feof | ( | UFILE * | f | ) |

Tests if the UFILE is at the end of the file stream.

Parameters:

  | f | The UFILE from which to read.

Returns:
  Returns TRUE after the first read operation that attempts to read past the end of the file. It returns FALSE if the current position is not end of file.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

void u_fflush | ( | UFILE * | file | ) |

Flush output of a UFILE.

Implies a flush of converter/transliterator state. (That is, a logical break is made in the output stream - for example if a different type of output is desired.) The underlying OS level file is also flushed.

Parameters:

  | file | The UFILE to flush.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

UChar u_fgetc | ( | UFILE * | f | ) |

Read a UChar from a UFILE.

It is recommended that `u_fgetcx` used instead for proper parsing functions, but sometimes reading code units is needed instead of codepoints.

Parameters:

  | f | The UFILE from which to read.

Returns:
  The UChar value read, or U+FFFF if no character was available.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

const char* u_fgetcodepage | ( | UFILE * | file | ) |

Get the codepage in which data is written to and read from the UFILE.

This is the same codepage passed in the preceding call to `u_fsetcodepage` or `u_fopen`.

Parameters:

  | file | The UFILE to query.

Returns:
  The codepage in which data is written to and read from the UFILE, or NULL if an error occurred.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

UConverter* u_fgetConverter | ( | UFILE * | f | ) |

Returns an alias to the converter being used for this file.

Parameters:

  | f | The UFILE to get the value from

Returns:
  alias to the converter

Draft:
  This API may be changed in the future versions and was introduced in 3.0

UChar32 u_fgetcx | ( | UFILE * | f | ) |

Read a UChar32 from a UFILE.

Parameters:

  | f | The UFILE from which to read.

Returns:
  The UChar32 value read, or U_EOF if no character was available, or U+FFFFFFFF if an ill-formed character was encountered.

See also:
  u_unescape()

Draft:
  This API may be changed in the future versions and was introduced in 3.0

FILE* u_fgetfile | ( | UFILE * | f | ) |

Get the FILE* associated with a UFILE.

Parameters:

  | f | The UFILE

Returns:
  A FILE*, owned by the UFILE. The FILE must not be closed.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

const char* u_fgetlocale | ( | UFILE * | file | ) |

Get the locale whose conventions are used to format and parse output.

This is the same locale passed in the preceding call to`u_fsetlocale` or `u_fopen`.

Parameters:

  | file | The UFILE to set.

Returns:
  The locale whose conventions are used to format and parse output.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

UChar* u_fgets | ( | UChar * | s,
|  | int32_t | n,
|  | UFILE * | f |
| ) |  |  |

Read one line of text into a UChar* string from a UFILE.

The newline at the end of the line is read into the string. The string is always null terminated

Parameters:

  | f | The UFILE from which to read.
  | n | The maximum number of characters - 1 to read.
  | s | The UChar* to receive the read data. Characters will be stored successively in `s` until a newline or EOF is reached. A null character (U+0000) will be appended to `s`.

Returns:
  A pointer to `s`, or NULL if no characters were available.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_file_read | ( | UChar * | chars,
|  | int32_t | count,
|  | UFILE * | f |
| ) |  |  |

Read Unicode from a UFILE.

Bytes will be converted from the UFILE's underlying codepage, with subsequent conversion to Unicode. The data will not be NULL terminated.

Parameters:

  | chars | A pointer to receive the Unicode data.
  | count | The number of Unicode characters to read.
  | f | The UFILE from which to read.

Returns:
  The number of Unicode characters read.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_file_write | ( | const UChar * | ustring,
|  | int32_t | count,
|  | UFILE * | f |
| ) |  |  |

Write Unicode to a UFILE.

The ustring passed in will be converted to the UFILE's underlying codepage before it is written.

Parameters:

  | ustring | A pointer to the Unicode data to write.
  | count | The number of Unicode characters to write
  | f | The UFILE to which to write.

Returns:
  The number of Unicode characters written.

See also:
  u_fputs

Draft:
  This API may be changed in the future versions and was introduced in 3.0

UFILE* u_finit | ( | FILE * | f,
|  | const char * | locale,
|  | const char * | codepage |
| ) |  |  |

Open a UFILE on top of an existing FILE* stream.

Parameters:

  | f | The FILE* to which this UFILE will attach.
  | locale | The locale whose conventions will be used to format and parse output. If this parameter is NULL, the default locale will be used.
  | codepage | The codepage in which data will be written to and read from the file. If this paramter is NULL, data will be written and read using the default codepage for `locale`, unless `locale` is NULL, in which case the system default codepage will be used.

Returns:
  A new UFILE, or NULL if an error occurred.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

UFILE* u_fopen | ( | const char * | filename,
|  | const char * | perm,
|  | const char * | locale,
|  | const char * | codepage |
| ) |  |  |

Open a UFILE.

A UFILE is a wrapper around a FILE* that is locale and codepage aware. That is, data written to a UFILE will be formatted using the conventions specified by that UFILE's Locale; this data will be in the character set specified by that UFILE's codepage.

Parameters:

  | filename | The name of the file to open.
  | perm | The read/write permission for the UFILE; one of "r", "w", "rw"
  | locale | The locale whose conventions will be used to format and parse output. If this parameter is NULL, the default locale will be used.
  | codepage | The codepage in which data will be written to and read from the file. If this paramter is NULL the system default codepage will be used.

Returns:
  A new UFILE, or NULL if an error occurred.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_fprintf | ( | UFILE * | f,
|  | const char * | patternSpecification,
|  |  | ... |
| ) |  |  |

Write formatted data to a UFILE.

Parameters:

  | f | The UFILE to which to write.
  | patternSpecification | A pattern specifying how `u_fprintf` will interpret the variable arguments received and format the data.

Returns:
  The number of Unicode characters written to `f`.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_fprintf_u | ( | UFILE * | f,
|  | const UChar * | patternSpecification,
|  |  | ... |
| ) |  |  |

Write formatted data to a UFILE.

Parameters:

  | f | The UFILE to which to write.
  | patternSpecification | A pattern specifying how `u_fprintf` will interpret the variable arguments received and format the data.

Returns:
  The number of Unicode characters written to `f`.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

UChar32 u_fputc | ( | UChar32 | uc,
|  | UFILE * | f |
| ) |  |  |

Write a UChar to a UFILE.

Parameters:

  | uc | The UChar to write.
  | f | The UFILE to which to write.

Returns:
  The character written if successful, EOF otherwise.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_fputs | ( | const UChar * | s,
|  | UFILE * | f |
| ) |  |  |

Write a Unicode to a UFILE.

The null (U+0000) terminated UChar* `s` will be written to `f`, excluding the NULL terminator. A newline will be added to `f`.

Parameters:

  | s | The UChar* to write.
  | f | The UFILE to which to write.

Returns:
  A non-negative number if successful, EOF otherwise.

See also:
  u_file_write

Draft:
  This API may be changed in the future versions and was introduced in 3.0

void u_frewind | ( | UFILE * | file | ) |

Rewind the file pointer to the beginning of the file.

Parameters:

  | file | The UFILE to rewind.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_fscanf | ( | UFILE * | f,
|  | const char * | patternSpecification,
|  |  | ... |
| ) |  |  |

Read formatted data from a UFILE.

Parameters:

  | f | The UFILE from which to read.
  | patternSpecification | A pattern specifying how `u_fscanf` will interpret the variable arguments received and parse the data.

Returns:
  The number of items successfully converted and assigned, or EOF if an error occurred.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_fscanf_u | ( | UFILE * | f,
|  | const UChar * | patternSpecification,
|  |  | ... |
| ) |  |  |

Read formatted data from a UFILE.

Parameters:

  | f | The UFILE from which to read.
  | patternSpecification | A pattern specifying how `u_fscanf` will interpret the variable arguments received and parse the data.

Returns:
  The number of items successfully converted and assigned, or EOF if an error occurred.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_fsetcodepage | ( | const char * | codepage,
|  | UFILE * | file |
| ) |  |  |

Set the codepage in which data will be written to and read from the UFILE.

All Unicode data written to the UFILE will be converted to this codepage before it is written to the underlying FILE*. It it generally a bad idea to mix codepages within a file. This should only be called right after opening the `UFile`, or after calling `u_frewind`.

Parameters:

  | codepage | The codepage in which data will be written to and read from the file. For example `"latin-1"` or `"ibm-943`. A value of NULL means the default codepage for the UFILE's current locale will be used.
  | file | The UFILE to set.

Returns:
  0 if successful, otherwise a negative number.

See also:
  u_frewind

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_fsetlocale | ( | UFILE * | file,
|  | const char * | locale |
| ) |  |  |

Set the locale whose conventions will be used to format and parse output.

Parameters:

  | locale | The locale whose conventions will be used to format and parse output.
  | file | The UFILE to query.

Returns:
  NULL if successful, otherwise a negative number.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

UTransliterator* u_fsettransliterator | ( | UFILE * | file,
|  | UFileDirection | direction,
|  | UTransliterator * | adopt,
|  | UErrorCode * | status |
| ) |  |  |

Set a transliterator on the UFILE.

The transliterator will be owned by the UFILE.

Parameters:

  | file | The UFILE to set transliteration on
  | adopt | The UTransliterator to set. Can be NULL, which will mean that no transliteration is used.
  | direction | either U_READ, U_WRITE, or U_READWRITE - sets which direction the transliterator is to be applied to. If U_READWRITE, the "Read" transliteration will be in the inverse direction.
  | status | ICU error code.

Returns:
  The previously set transliterator, owned by the caller. If U_READWRITE is specified, only the WRITE transliterator is returned. In most cases, the caller should call utrans_close() on the result of this function.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

UFILE* u_fstropen | ( | UChar * | stringBuf,
|  | int32_t | capacity,
|  | const char * | locale |
| ) |  |  |

Create a UFILE that can be used for localized formatting or parsing.

The u_sprintf and u_sscanf functions do not read or write numbers for a specific locale. The ustdio.h file functions can be used on this UFILE. The string is usable once u_fclose or u_fflush has been called on the returned UFILE.

Parameters:

  | stringBuf | The string used for reading or writing.
  | capacity | The number of code units available for use in stringBuf
  | locale | The locale whose conventions will be used to format and parse output. If this parameter is NULL, the default locale will be used.

Returns:
  A new UFILE, or NULL if an error occurred.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

UChar32 u_fungetc | ( | UChar32 | c,
|  | UFILE * | f |
| ) |  |  |

Unget a UChar from a UFILE.

If this function is not the first to operate on `f` after a call to `u_fgetc`, the results are undefined. If this function is passed a character that was not recieved from the previous `u_fgetc` or `u_fgetcx` call, the results are undefined.

Parameters:

  | c | The UChar to put back on the stream.
  | f | The UFILE to receive `c`.

Returns:
  The UChar32 value put back if successful, U_EOF otherwise.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_snprintf | ( | UChar * | buffer,
|  | int32_t | count,
|  | const char * | patternSpecification,
|  |  | ... |
| ) |  |  |

Write formatted data to a Unicode string.

When the number of code units required to store the data exceeds `count`, then `count` code units of data are stored in `buffer` and a negative value is returned. When the number of code units required to store the data equals `count`, the string is not null terminated and `count` is returned.

Parameters:

  | buffer | The Unicode String to which to write.
  | count | The number of code units to read.
  | patternSpecification | A pattern specifying how `u_sprintf` will interpret the variable arguments received and format the data.

Returns:
  The number of Unicode code units written to `buffer`. This does not include the terminating null character.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_snprintf_u | ( | UChar * | buffer,
|  | int32_t | count,
|  | const UChar * | patternSpecification,
|  |  | ... |
| ) |  |  |

Write formatted data to a Unicode string.

When the number of code units required to store the data exceeds `count`, then `count` code units of data are stored in `buffer` and a negative value is returned. When the number of code units required to store the data equals `count`, the string is not null terminated and `count` is returned.

Parameters:

  | buffer | The Unicode string to which to write.
  | count | The number of code units to read.
  | patternSpecification | A pattern specifying how `u_sprintf` will interpret the variable arguments received and format the data.

Returns:
  The number of Unicode characters written to `buffer`.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_sprintf | ( | UChar * | buffer,
|  | const char * | patternSpecification,
|  |  | ... |
| ) |  |  |

Write formatted data to a Unicode string.

Parameters:

  | buffer | The Unicode String to which to write.
  | patternSpecification | A pattern specifying how `u_sprintf` will interpret the variable arguments received and format the data.

Returns:
  The number of Unicode code units written to `buffer`. This does not include the terminating null character.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_sprintf_u | ( | UChar * | buffer,
|  | const UChar * | patternSpecification,
|  |  | ... |
| ) |  |  |

Write formatted data to a Unicode string.

Parameters:

  | buffer | The Unicode string to which to write.
  | patternSpecification | A pattern specifying how `u_sprintf` will interpret the variable arguments received and format the data.

Returns:
  The number of Unicode characters written to `buffer`.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_sscanf | ( | const UChar * | buffer,
|  | const char * | patternSpecification,
|  |  | ... |
| ) |  |  |

Read formatted data from a Unicode string.

Parameters:

  | buffer | The Unicode string from which to read.
  | patternSpecification | A pattern specifying how `u_sscanf` will interpret the variable arguments received and parse the data.

Returns:
  The number of items successfully converted and assigned, or EOF if an error occurred.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_sscanf_u | ( | const UChar * | buffer,
|  | const UChar * | patternSpecification,
|  |  | ... |
| ) |  |  |

Read formatted data from a Unicode string.

Parameters:

  | buffer | The Unicode string from which to read.
  | patternSpecification | A pattern specifying how `u_sscanf` will interpret the variable arguments received and parse the data.

Returns:
  The number of items successfully converted and assigned, or EOF if an error occurred.

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_vfprintf | ( | UFILE * | f,
|  | const char * | patternSpecification,
|  | va_list | ap |
| ) |  |  |

Write formatted data to a UFILE.

This is identical to `u_fprintf`, except that it will not call `va_start` and `va_end`.

Parameters:

  | f | The UFILE to which to write.
  | patternSpecification | A pattern specifying how `u_fprintf` will interpret the variable arguments received and format the data.
  | ap | The argument list to use.

Returns:
  The number of Unicode characters written to `f`.

See also:
  u_fprintf

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_vfprintf_u | ( | UFILE * | f,
|  | const UChar * | patternSpecification,
|  | va_list | ap |
| ) |  |  |

Write formatted data to a UFILE.

This is identical to `u_fprintf_u`, except that it will not call `va_start` and `va_end`.

Parameters:

  | f | The UFILE to which to write.
  | patternSpecification | A pattern specifying how `u_fprintf` will interpret the variable arguments received and format the data.
  | ap | The argument list to use.

Returns:
  The number of Unicode characters written to `f`.

See also:
  u_fprintf_u

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_vfscanf | ( | UFILE * | f,
|  | const char * | patternSpecification,
|  | va_list | ap |
| ) |  |  |

Read formatted data from a UFILE.

This is identical to `u_fscanf`, except that it will not call `va_start` and `va_end`.

Parameters:

  | f | The UFILE from which to read.
  | patternSpecification | A pattern specifying how `u_fscanf` will interpret the variable arguments received and parse the data.
  | ap | The argument list to use.

Returns:
  The number of items successfully converted and assigned, or EOF if an error occurred.

See also:
  u_fscanf

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_vfscanf_u | ( | UFILE * | f,
|  | const UChar * | patternSpecification,
|  | va_list | ap |
| ) |  |  |

Read formatted data from a UFILE.

This is identical to `u_fscanf_u`, except that it will not call `va_start` and `va_end`.

Parameters:

  | f | The UFILE from which to read.
  | patternSpecification | A pattern specifying how `u_fscanf` will interpret the variable arguments received and parse the data.
  | ap | The argument list to use.

Returns:
  The number of items successfully converted and assigned, or EOF if an error occurred.

See also:
  u_fscanf_u

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_vsnprintf | ( | UChar * | buffer,
|  | int32_t | count,
|  | const char * | patternSpecification,
|  | va_list | ap |
| ) |  |  |

Write formatted data to a Unicode string.

This is identical to `u_snprintf`, except that it will not call `va_start` and `va_end`.
When the number of code units required to store the data exceeds `count`, then `count` code units of data are stored in `buffer` and a negative value is returned. When the number of code units required to store the data equals `count`, the string is not null terminated and `count` is returned.

Parameters:

  | buffer | The Unicode string to which to write.
  | count | The number of code units to read.
  | patternSpecification | A pattern specifying how `u_sprintf` will interpret the variable arguments received and format the data.
  | ap | The argument list to use.

Returns:
  The number of Unicode characters written to `buffer`.

See also:
  u_sprintf

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_vsnprintf_u | ( | UChar * | buffer,
|  | int32_t | count,
|  | const UChar * | patternSpecification,
|  | va_list | ap |
| ) |  |  |

Write formatted data to a Unicode string.

This is identical to `u_snprintf_u`, except that it will not call `va_start` and `va_end`. When the number of code units required to store the data exceeds `count`, then `count` code units of data are stored in `buffer` and a negative value is returned. When the number of code units required to store the data equals `count`, the string is not null terminated and `count` is returned.

Parameters:

  | buffer | The Unicode string to which to write.
  | count | The number of code units to read.
  | patternSpecification | A pattern specifying how `u_sprintf` will interpret the variable arguments received and format the data.
  | ap | The argument list to use.

Returns:
  The number of Unicode characters written to `f`.

See also:
  u_sprintf_u

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_vsprintf | ( | UChar * | buffer,
|  | const char * | patternSpecification,
|  | va_list | ap |
| ) |  |  |

Write formatted data to a Unicode string.

This is identical to `u_sprintf`, except that it will not call `va_start` and `va_end`.

Parameters:

  | buffer | The Unicode string to which to write.
  | patternSpecification | A pattern specifying how `u_sprintf` will interpret the variable arguments received and format the data.
  | ap | The argument list to use.

Returns:
  The number of Unicode characters written to `buffer`.

See also:
  u_sprintf

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_vsprintf_u | ( | UChar * | buffer,
|  | const UChar * | patternSpecification,
|  | va_list | ap |
| ) |  |  |

Write formatted data to a Unicode string.

This is identical to `u_sprintf_u`, except that it will not call `va_start` and `va_end`.

Parameters:

  | buffer | The Unicode string to which to write.
  | patternSpecification | A pattern specifying how `u_sprintf` will interpret the variable arguments received and format the data.
  | ap | The argument list to use.

Returns:
  The number of Unicode characters written to `f`.

See also:
  u_sprintf_u

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_vsscanf | ( | const UChar * | buffer,
|  | const char * | patternSpecification,
|  | va_list | ap |
| ) |  |  |

Read formatted data from a Unicode string.

This is identical to `u_sscanf`, except that it will not call `va_start` and `va_end`.

Parameters:

  | buffer | The Unicode string from which to read.
  | patternSpecification | A pattern specifying how `u_sscanf` will interpret the variable arguments received and parse the data.
  | ap | The argument list to use.

Returns:
  The number of items successfully converted and assigned, or EOF if an error occurred.

See also:
  u_sscanf

Draft:
  This API may be changed in the future versions and was introduced in 3.0

int32_t u_vsscanf_u | ( | const UChar * | buffer,
|  | const UChar * | patternSpecification,
|  | va_list | ap |
| ) |  |  |

Read formatted data from a Unicode string.

This is identical to `u_sscanf_u`, except that it will not call `va_start` and `va_end`.

Parameters:

  | buffer | The Unicode string from which to read.
  | patternSpecification | A pattern specifying how `u_sscanf` will interpret the variable arguments received and parse the data.
  | ap | The argument list to use.

Returns:
  The number of items successfully converted and assigned, or EOF if an error occurred.

See also:
  u_sscanf_u

Draft:
  This API may be changed in the future versions and was introduced in 3.0